<html>
<head>
<title>OgreRenderQueue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderQueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderQueue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderQueue_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderQueue_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderPrefix_8h.html">OgreHeaderPrefix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037     <span class="keyword">class </span>Camera;
<a name="l00038"></a>00038     <span class="keyword">class </span>MovableObject;
<a name="l00039"></a>00039     <span class="keyword">struct </span>VisibleObjectsBoundsInfo;
<a name="l00040"></a>00040 
<a name="l00053"></a><a class="code" href="group__RenderSystem.html#gad08013a341ff0ef07c39fa3502bf6c00">00053</a>     <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#gad08013a341ff0ef07c39fa3502bf6c00" title="Enumeration of queue groups, by which the application may group queued renderables so that they are r...">RenderQueueGroupID</a>
<a name="l00054"></a>00054     {
<a name="l00056"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a6f63169671858ecbaf90d237f5726cd4">00056</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a6f63169671858ecbaf90d237f5726cd4" title="Use this queue for objects which must be rendered first e.g. backgrounds.">RENDER_QUEUE_BACKGROUND</a> = 0,
<a name="l00058"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a85a7c54f44b9ac82523d80d19b6b2394">00058</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a85a7c54f44b9ac82523d80d19b6b2394" title="First queue (after backgrounds), used for skyboxes if rendered first.">RENDER_QUEUE_SKIES_EARLY</a> = 5,
<a name="l00059"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a82534671938c174a7d681d89083ef7db">00059</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a82534671938c174a7d681d89083ef7db">RENDER_QUEUE_1</a> = 10,
<a name="l00060"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a53b5d66a0512dfd2c311d7cc66b20381">00060</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a53b5d66a0512dfd2c311d7cc66b20381">RENDER_QUEUE_2</a> = 20,
<a name="l00061"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00ade11af91b1f43096ff932b9c3843e5e4">00061</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00ade11af91b1f43096ff932b9c3843e5e4">RENDER_QUEUE_WORLD_GEOMETRY_1</a> = 25,
<a name="l00062"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a72b7acba73734142cfa10e9cc75962c9">00062</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a72b7acba73734142cfa10e9cc75962c9">RENDER_QUEUE_3</a> = 30,
<a name="l00063"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a9e2ea42071d435e220510e556cd7406c">00063</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a9e2ea42071d435e220510e556cd7406c">RENDER_QUEUE_4</a> = 40,
<a name="l00065"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00af9d31cc0cad8ce9890b4af5f9014f5be">00065</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00af9d31cc0cad8ce9890b4af5f9014f5be" title="The default render queue.">RENDER_QUEUE_MAIN</a> = 50,
<a name="l00066"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a531fdb018ca4d5ff2ba7a97fba949bbe">00066</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a531fdb018ca4d5ff2ba7a97fba949bbe">RENDER_QUEUE_6</a> = 60,
<a name="l00067"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00abc64da9d300b2d65a19e5fc0bfa05d58">00067</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00abc64da9d300b2d65a19e5fc0bfa05d58">RENDER_QUEUE_7</a> = 70,
<a name="l00068"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a256a799730f10076007fd0411e033b1f">00068</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a256a799730f10076007fd0411e033b1f">RENDER_QUEUE_WORLD_GEOMETRY_2</a> = 75,
<a name="l00069"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a31ac7ce7cf426c952976a3fdcc3e4e8e">00069</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a31ac7ce7cf426c952976a3fdcc3e4e8e">RENDER_QUEUE_8</a> = 80,
<a name="l00070"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a5c4ab4460dc0489bbc5ea049d8412d21">00070</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a5c4ab4460dc0489bbc5ea049d8412d21">RENDER_QUEUE_9</a> = 90,
<a name="l00072"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a53468f34583f3a469cc8ca2f444fb6ff">00072</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a53468f34583f3a469cc8ca2f444fb6ff" title="Penultimate queue(before overlays), used for skyboxes if rendered last.">RENDER_QUEUE_SKIES_LATE</a> = 95,
<a name="l00074"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a51f548bb157ad908542478155f7d807b">00074</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a51f548bb157ad908542478155f7d807b" title="Use this queue for objects which must be rendered last e.g. overlays.">RENDER_QUEUE_OVERLAY</a> = 100, 
<a name="l00076"></a><a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1">00076</a>         <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a> = 105
<a name="l00077"></a>00077     };
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="group__RenderSystem.html#gaf7eb718b406b59b1762c3e37b90212b3">00079</a> <span class="preprocessor">    #define OGRE_RENDERABLE_DEFAULT_PRIORITY  100</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00092"></a><a class="code" href="classOgre_1_1RenderQueue.html">00092</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderQueueAlloc</a>
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094     <span class="keyword">public</span>:
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">00096</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a>
<a name="l00097"></a>00097         {
<a name="l00098"></a>00098         <span class="keyword">public</span>:
<a name="l00099"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">00099</a>             <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>
<a name="l00100"></a>00100             {
<a name="l00101"></a>00101             <span class="keyword">public</span>:
<a name="l00102"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#ac56bd2f16746c0f0cbd959dd79d79133">00102</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> _f, <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* _g) : first(_f), second(_g)
<a name="l00103"></a>00103                 {
<a name="l00104"></a>00104 
<a name="l00105"></a>00105                 }
<a name="l00106"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a5c979aa2f3d376d152e2f8e629e8b9db">00106</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>() : first(0), second(0)
<a name="l00107"></a>00107                 {
<a name="l00108"></a>00108 
<a name="l00109"></a>00109                 }
<a name="l00110"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">00110</a>                 <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a>;
<a name="l00111"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a4a4eea2dfe476cfdcdda19f74044eb1e">00111</a>                 <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a4a4eea2dfe476cfdcdda19f74044eb1e">second</a>;
<a name="l00112"></a>00112             };
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#af4fe0c695ef8be1b98257188ec9f3ea6">00114</a>             <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#af4fe0c695ef8be1b98257188ec9f3ea6">key_type</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#adac14e31c7638704e307ce0f8c3839de">00115</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#adac14e31c7638704e307ce0f8c3839de">mapped_type</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a463c524952c8d1b82e9abfa4084d2716">00116</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>&amp; <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a463c524952c8d1b82e9abfa4084d2716">reference</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a357a5f81804f7101b3de17d68d080e0a">00117</a>             <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>* <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a357a5f81804f7101b3de17d68d080e0a">pointer</a>;
<a name="l00118"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a17ebdda6ce67602d0fb09deff3d262c8">00118</a>             <span class="keyword">typedef</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>&amp; <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a17ebdda6ce67602d0fb09deff3d262c8">const_reference</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ac0863258f4002e466210c77b5b9da73b">00119</a>             <span class="keyword">typedef</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a>* <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ac0863258f4002e466210c77b5b9da73b">const_pointer</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ae2839e91c9aa216a7cbabdb8cd4b0599">00120</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;value_type &gt;::type</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ae2839e91c9aa216a7cbabdb8cd4b0599">GroupVector</a>;
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">00122</a>             <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>
<a name="l00123"></a>00123             {
<a name="l00124"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#aa0345a1cad831efba15b87b9bb39b450">00124</a>                 <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a>;
<a name="l00125"></a>00125             <span class="keyword">public</span>:
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a1f2e77f19f18a469848309f26f34e9dc">00127</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>() : mRenderQueueGroupMap(0), mIndex(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>)
<a name="l00128"></a>00128                 {
<a name="l00129"></a>00129                 }
<a name="l00130"></a>00130 
<a name="l00131"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#acff84cd31acf27c545c8fe826824cc73">00131</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a>* _mRenderQueueGroupMap, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> _index) : mRenderQueueGroupMap(_mRenderQueueGroupMap), mIndex(_index)
<a name="l00132"></a>00132                 {
<a name="l00133"></a>00133                 }
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a15f489370138a6a29d22948e179dc427">00135</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">const_reference</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator*</a>()<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword">                </span>{   
<a name="l00137"></a>00137                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139                     <span class="keywordflow">return</span> mRenderQueueGroupMap-&gt;mGroupVector[mIndex];
<a name="l00140"></a>00140                 }
<a name="l00141"></a>00141 
<a name="l00142"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a16132ab23b90fe7b25ec8682718e7753">00142</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">const_pointer</a> operator-&gt;()<span class="keyword"> const</span>
<a name="l00143"></a>00143 <span class="keyword">                </span>{
<a name="l00144"></a>00144                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146                     <span class="keywordflow">return</span> &amp;(mRenderQueueGroupMap-&gt;mGroupVector[mIndex]);
<a name="l00147"></a>00147                 }
<a name="l00148"></a>00148 
<a name="l00149"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#ad55d9f1e9bfa118e5a172c17108a1420">00149</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>&amp; operator++()
<a name="l00150"></a>00150                 {
<a name="l00151"></a>00151                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153                     <span class="keywordflow">while</span>(mIndex &lt; mRenderQueueGroupMap-&gt;mMaxID)
<a name="l00154"></a>00154                     {
<a name="l00155"></a>00155                         ++mIndex;
<a name="l00156"></a>00156                         <span class="keywordflow">if</span>(mRenderQueueGroupMap-&gt;mGroupVector[mIndex].second != 0)
<a name="l00157"></a>00157                         {
<a name="l00158"></a>00158                             <span class="keywordflow">break</span>;
<a name="l00159"></a>00159                         }
<a name="l00160"></a>00160                     }
<a name="l00161"></a>00161                     <span class="keywordflow">return</span> (*<span class="keyword">this</span>);
<a name="l00162"></a>00162                 }
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#ac4af5861c2e8aa8118196860fd46e2d4">00164</a>                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>&amp; operator++()<span class="keyword">const</span>
<a name="l00165"></a>00165 <span class="keyword">                </span>{
<a name="l00166"></a>00166                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168                     <span class="keywordflow">while</span>(mIndex &lt; mRenderQueueGroupMap-&gt;mMaxID)
<a name="l00169"></a>00169                     {
<a name="l00170"></a>00170                         ++mIndex;
<a name="l00171"></a>00171                         <span class="keywordflow">if</span>(mRenderQueueGroupMap-&gt;mGroupVector[mIndex].second != 0)
<a name="l00172"></a>00172                         {
<a name="l00173"></a>00173                             <span class="keywordflow">break</span>;
<a name="l00174"></a>00174                         }
<a name="l00175"></a>00175                     }
<a name="l00176"></a>00176                     <span class="keywordflow">return</span> (*<span class="keyword">this</span>);
<a name="l00177"></a>00177                 }
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a1b6430a421025342769964432d29b677">00179</a>                 <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> operator++(<span class="keywordtype">int</span>)
<a name="l00180"></a>00180                 {
<a name="l00181"></a>00181                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183                     <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> temp = *<span class="keyword">this</span>;
<a name="l00184"></a>00184                     <span class="keywordflow">while</span>(mIndex &lt; mRenderQueueGroupMap-&gt;mMaxID)
<a name="l00185"></a>00185                     {
<a name="l00186"></a>00186                         ++mIndex;
<a name="l00187"></a>00187                         <span class="keywordflow">if</span>(mRenderQueueGroupMap-&gt;mGroupVector[mIndex].second != 0)
<a name="l00188"></a>00188                         {
<a name="l00189"></a>00189                             <span class="keywordflow">break</span>;
<a name="l00190"></a>00190                         }
<a name="l00191"></a>00191                     }
<a name="l00192"></a>00192                     <span class="keywordflow">return</span> (temp);
<a name="l00193"></a>00193                 }
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#ac98371b7d24e8a330c48a7f48db4f5fe">00195</a>                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> operator++(<span class="keywordtype">int</span>)<span class="keyword">const</span>
<a name="l00196"></a>00196 <span class="keyword">                </span>{
<a name="l00197"></a>00197                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199                     <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">const_iterator</a> temp = *<span class="keyword">this</span>;
<a name="l00200"></a>00200                     <span class="keywordflow">while</span>(mIndex &lt; mRenderQueueGroupMap-&gt;mMaxID)
<a name="l00201"></a>00201                     {
<a name="l00202"></a>00202                         ++mIndex;
<a name="l00203"></a>00203                         <span class="keywordflow">if</span>(mRenderQueueGroupMap-&gt;mGroupVector[mIndex].second != 0)
<a name="l00204"></a>00204                         {
<a name="l00205"></a>00205                             <span class="keywordflow">break</span>;
<a name="l00206"></a>00206                         }
<a name="l00207"></a>00207                     }
<a name="l00208"></a>00208                     <span class="keywordflow">return</span> (temp);
<a name="l00209"></a>00209                 }
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a8d4ab3d5a9f012e9ead6d9ebc7e1fd9d">00211</a>                 <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator !=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>&amp; o)<span class="keyword">const</span>
<a name="l00212"></a>00212 <span class="keyword">                </span>{
<a name="l00213"></a>00213                     assert(mRenderQueueGroupMap);
<a name="l00214"></a>00214                     assert(o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">mRenderQueueGroupMap</a>);
<a name="l00215"></a>00215                     assert(o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">mRenderQueueGroupMap</a> == this-&gt;mRenderQueueGroupMap);
<a name="l00216"></a>00216                     <span class="keywordflow">if</span>( o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a58470bacee8d468971610bbad6b221c1">mIndex</a> != this-&gt;mIndex)
<a name="l00217"></a>00217                         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00218"></a>00218                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00219"></a>00219                 }
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a45122b427e0fa2527ad1551a3ef1a837">00221</a>                 <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator ==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>&amp; o)<span class="keyword">const</span>
<a name="l00222"></a>00222 <span class="keyword">                </span>{
<a name="l00223"></a>00223                     assert(this-&gt;mRenderQueueGroupMap);
<a name="l00224"></a>00224                     assert(o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">mRenderQueueGroupMap</a>);
<a name="l00225"></a>00225                     assert(o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">mRenderQueueGroupMap</a> == this-&gt;mRenderQueueGroupMap);
<a name="l00226"></a>00226                     <span class="keywordflow">if</span>(o.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a58470bacee8d468971610bbad6b221c1">mIndex</a> == this-&gt;mIndex)
<a name="l00227"></a>00227                     {
<a name="l00228"></a>00228                         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00229"></a>00229                     }
<a name="l00230"></a>00230                     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00231"></a>00231                 }
<a name="l00232"></a>00232             <span class="keyword">protected</span>:
<a name="l00233"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">00233</a>                 <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a>* <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a313c5b8b2d743630f422bea91294fae7">mRenderQueueGroupMap</a>;
<a name="l00234"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a58470bacee8d468971610bbad6b221c1">00234</a>                 <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html#a58470bacee8d468971610bbad6b221c1">mIndex</a>;
<a name="l00235"></a>00235             };
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a4b619649e7e23c4d1882c609b741d53f">00237</a>             <span class="keyword">typedef</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a4b619649e7e23c4d1882c609b741d53f">const_iterator</a>;
<a name="l00238"></a>00238             
<a name="l00239"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ab0333da5f66027e4242721d00f498cd9">00239</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a>() : mMinID(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>), mMaxID(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>)
<a name="l00240"></a>00240             {
<a name="l00241"></a>00241                 mGroupVector.resize(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a> + 2);
<a name="l00242"></a>00242             }
<a name="l00243"></a>00243 
<a name="l00244"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a17731b1d6c673342f896517a81afdb0f">00244</a>             <span class="keywordtype">void</span> insert(<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html">value_type</a> v)
<a name="l00245"></a>00245             {
<a name="l00246"></a>00246                 mGroupVector[v.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a>] = v;
<a name="l00247"></a>00247                 <span class="keywordflow">if</span>(v.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a> &lt; mMinID)
<a name="l00248"></a>00248                 {
<a name="l00249"></a>00249                     mMinID = v.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a>;
<a name="l00250"></a>00250                 }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252                 <span class="keywordflow">if</span>(v.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a> &gt;= mMaxID || mMaxID == <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>)
<a name="l00253"></a>00253                 {
<a name="l00254"></a>00254                     mMaxID = v.<a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1value__type.html#a2859921f02f52dd00ad33345d907ac31">first</a> + 1;
<a name="l00255"></a>00255                 }
<a name="l00256"></a>00256             }
<a name="l00257"></a>00257 
<a name="l00258"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a0da6f5381814fe5173f63016d9c27c49">00258</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> find(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> key)
<a name="l00259"></a>00259             {
<a name="l00260"></a>00260                 <span class="keywordflow">if</span>(mGroupVector[key].second == 0)
<a name="l00261"></a>00261                 {
<a name="l00262"></a>00262                     <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, mMaxID);
<a name="l00263"></a>00263                 }
<a name="l00264"></a>00264                 <span class="keywordflow">else</span>
<a name="l00265"></a>00265                 {
<a name="l00266"></a>00266                     <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, key);
<a name="l00267"></a>00267                 }
<a name="l00268"></a>00268             }
<a name="l00269"></a>00269 
<a name="l00270"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a460eb2da82a3d0b35cb03402faef6d52">00270</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> begin()
<a name="l00271"></a>00271             {
<a name="l00272"></a>00272                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, mMinID);
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274 
<a name="l00275"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a1851bb38e49b158195686920f13f2c09">00275</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a> end()
<a name="l00276"></a>00276             {
<a name="l00277"></a>00277                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, mMaxID);
<a name="l00278"></a>00278             }
<a name="l00279"></a>00279 
<a name="l00280"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#af2e0bfdbf8a7e1fa2246c8955dbf081a">00280</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">const_iterator</a> begin()<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword">            </span>{
<a name="l00282"></a>00282                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, mMinID);
<a name="l00283"></a>00283             }
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#acdf7e28a39f67f92e042ab81daa552d5">00285</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">const_iterator</a> end()<span class="keyword"> const</span>
<a name="l00286"></a>00286 <span class="keyword">            </span>{
<a name="l00287"></a>00287                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap_1_1iterator.html">iterator</a>(<span class="keyword">this</span>, mMaxID);
<a name="l00288"></a>00288             }
<a name="l00289"></a>00289             
<a name="l00290"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a9003a4f2d9e51418c009ee344bcc925e">00290</a>             <span class="keywordtype">void</span> clear()
<a name="l00291"></a>00291             {
<a name="l00292"></a>00292                 mGroupVector.reserve(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a> + 2);
<a name="l00293"></a>00293                 mGroupVector.clear();
<a name="l00294"></a>00294                 mGroupVector.resize(<a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a> + 2);
<a name="l00295"></a>00295                 mMinID = <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>;
<a name="l00296"></a>00296                 mMaxID = <a class="code" href="group__RenderSystem.html#ggad08013a341ff0ef07c39fa3502bf6c00a2d1e261d9e3298b1cb7272b392f550b1" title="Final possible render queue, don&#39;t exceed this.">RENDER_QUEUE_MAX</a>;
<a name="l00297"></a>00297             }
<a name="l00298"></a>00298         <span class="keyword">protected</span>:
<a name="l00299"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a4bb3cfbdf6932a106ad5734ff345734a">00299</a>             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a4bb3cfbdf6932a106ad5734ff345734a">mMinID</a>;
<a name="l00300"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a762fda1b2d912eaa507511a94a02e338">00300</a>             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#a762fda1b2d912eaa507511a94a02e338">mMaxID</a>;
<a name="l00301"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ac602d6b828a5817142e2598e4daf86c1">00301</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ae2839e91c9aa216a7cbabdb8cd4b0599">GroupVector</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html#ac602d6b828a5817142e2598e4daf86c1">mGroupVector</a>;
<a name="l00302"></a>00302         };
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classOgre_1_1RenderQueue.html#a4cf42f3f073ba37a87a555e37143ed1e">00304</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;RenderQueueGroupMap&gt;</a> <a class="code" href="classOgre_1_1RenderQueue.html#a4cf42f3f073ba37a87a555e37143ed1e">QueueGroupIterator</a>;
<a name="l00305"></a><a class="code" href="classOgre_1_1RenderQueue.html#add383352b6e187bfd9ee4f09753df493">00305</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;RenderQueueGroupMap&gt;</a> <a class="code" href="classOgre_1_1RenderQueue.html#add383352b6e187bfd9ee4f09753df493">ConstQueueGroupIterator</a>;
<a name="l00306"></a>00306 
<a name="l00312"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html">00312</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>
<a name="l00313"></a>00313         {
<a name="l00314"></a>00314         <span class="keyword">public</span>:
<a name="l00315"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#a0820da08b1cfaa649e9795e005161d98">00315</a>             <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#a0820da08b1cfaa649e9795e005161d98">RenderableListener</a>() {}
<a name="l00316"></a><a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#aa1cf2797eb257b192b5a7f4d7927bce6">00316</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html#aa1cf2797eb257b192b5a7f4d7927bce6">~RenderableListener</a>() {}
<a name="l00317"></a>00317 
<a name="l00337"></a>00337             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> renderableQueued(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* rend, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupID, 
<a name="l00338"></a>00338                 <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority, <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>** ppTech, <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* pQueue) = 0;
<a name="l00339"></a>00339         };
<a name="l00340"></a>00340     <span class="keyword">protected</span>:
<a name="l00341"></a><a class="code" href="classOgre_1_1RenderQueue.html#aaf91a53059c0a0f61c07d3a0753a3bfe">00341</a>         <a class="code" href="classOgre_1_1RenderQueue_1_1RenderQueueGroupMap.html">RenderQueueGroupMap</a> <a class="code" href="classOgre_1_1RenderQueue.html#aaf91a53059c0a0f61c07d3a0753a3bfe">mGroups</a>;
<a name="l00343"></a><a class="code" href="classOgre_1_1RenderQueue.html#a7166e043e0913cb1e08e4737befce3f6">00343</a>         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1RenderQueue.html#a7166e043e0913cb1e08e4737befce3f6" title="The current default queue group.">mDefaultQueueGroup</a>;
<a name="l00345"></a><a class="code" href="classOgre_1_1RenderQueue.html#af1e1472401b4e1d24676e60d41b4705d">00345</a>         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="code" href="classOgre_1_1RenderQueue.html#af1e1472401b4e1d24676e60d41b4705d" title="The default priority.">mDefaultRenderablePriority</a>;
<a name="l00346"></a>00346 
<a name="l00347"></a><a class="code" href="classOgre_1_1RenderQueue.html#af5adba44e7d9c936efcb35d389d5bb58">00347</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueue.html#af5adba44e7d9c936efcb35d389d5bb58">mSplitPassesByLightingType</a>;
<a name="l00348"></a><a class="code" href="classOgre_1_1RenderQueue.html#a66986fa9c851664d568e3dbb5a2d40cb">00348</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueue.html#a66986fa9c851664d568e3dbb5a2d40cb">mSplitNoShadowPasses</a>;
<a name="l00349"></a><a class="code" href="classOgre_1_1RenderQueue.html#abfb15a31918778ed0e0c74aacf3358f6">00349</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderQueue.html#abfb15a31918778ed0e0c74aacf3358f6">mShadowCastersCannotBeReceivers</a>;
<a name="l00350"></a>00350 
<a name="l00351"></a><a class="code" href="classOgre_1_1RenderQueue.html#add07814ff649c3a7a914fa3961a83a3d">00351</a>         <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* <a class="code" href="classOgre_1_1RenderQueue.html#add07814ff649c3a7a914fa3961a83a3d">mRenderableListener</a>;
<a name="l00352"></a>00352     <span class="keyword">public</span>:
<a name="l00353"></a>00353         <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>();
<a name="l00354"></a>00354         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>();
<a name="l00355"></a>00355 
<a name="l00360"></a>00360         <span class="keywordtype">void</span> clear(<span class="keywordtype">bool</span> destroyPassMaps = <span class="keyword">false</span>);
<a name="l00361"></a>00361 
<a name="l00367"></a>00367         <a class="code" href="classOgre_1_1RenderQueueGroup.html" title="A grouping level underneath RenderQueue which groups renderables to be issued at coarsely the same ti...">RenderQueueGroup</a>* getQueueGroup(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> qid);
<a name="l00368"></a>00368 
<a name="l00391"></a>00391         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupID, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority);
<a name="l00392"></a>00392 
<a name="l00410"></a>00410         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> groupId);
<a name="l00411"></a>00411 
<a name="l00424"></a>00424         <span class="keywordtype">void</span> addRenderable(<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>* pRend);
<a name="l00425"></a>00425         
<a name="l00429"></a>00429         <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getDefaultQueueGroup(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00430"></a>00430 
<a name="l00435"></a>00435         <span class="keywordtype">void</span> setDefaultRenderablePriority(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> priority);
<a name="l00436"></a>00436 
<a name="l00440"></a>00440         <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getDefaultRenderablePriority(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00441"></a>00441 
<a name="l00446"></a>00446         <span class="keywordtype">void</span> setDefaultQueueGroup(<a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> grp);
<a name="l00447"></a>00447         
<a name="l00449"></a>00449         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">QueueGroupIterator</a> _getQueueGroupIterator(<span class="keywordtype">void</span>);
<a name="l00450"></a>00450         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstQueueGroupIterator</a> _getQueueGroupIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00451"></a>00451 
<a name="l00455"></a>00455         <span class="keywordtype">void</span> setSplitPassesByLightingType(<span class="keywordtype">bool</span> split);
<a name="l00456"></a>00456 
<a name="l00460"></a>00460         <span class="keywordtype">bool</span> getSplitPassesByLightingType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00461"></a>00461 
<a name="l00466"></a>00466         <span class="keywordtype">void</span> setSplitNoShadowPasses(<span class="keywordtype">bool</span> split);
<a name="l00467"></a>00467 
<a name="l00472"></a>00472         <span class="keywordtype">bool</span> getSplitNoShadowPasses(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00473"></a>00473 
<a name="l00477"></a>00477         <span class="keywordtype">void</span> setShadowCastersCannotBeReceivers(<span class="keywordtype">bool</span> ind);
<a name="l00478"></a>00478 
<a name="l00482"></a>00482         <span class="keywordtype">bool</span> getShadowCastersCannotBeReceivers(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00483"></a>00483 
<a name="l00489"></a><a class="code" href="classOgre_1_1RenderQueue.html#a4830aa759ae0619a637dc979f8f0d581">00489</a>         <span class="keywordtype">void</span> setRenderableListener(<a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* listener)
<a name="l00490"></a>00490         { mRenderableListener = listener; }
<a name="l00491"></a>00491 
<a name="l00492"></a><a class="code" href="classOgre_1_1RenderQueue.html#a0833e163d52c2fffef84dfe81af1606a">00492</a>         <a class="code" href="classOgre_1_1RenderQueue_1_1RenderableListener.html" title="Class to listen in on items being added to the render queue.">RenderableListener</a>* getRenderableListener(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00493"></a>00493 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mRenderableListener; }
<a name="l00494"></a>00494 
<a name="l00497"></a>00497         <span class="keywordtype">void</span> merge( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* rhs );
<a name="l00503"></a>00503         <span class="keywordtype">void</span> processVisibleObject(<a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>* mo, 
<a name="l00504"></a>00504             <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, 
<a name="l00505"></a>00505             <span class="keywordtype">bool</span> onlyShadowCasters, 
<a name="l00506"></a>00506             <a class="code" href="structOgre_1_1VisibleObjectsBoundsInfo.html" title="Structure collecting together information about the visible objects that have been discovered in a sc...">VisibleObjectsBoundsInfo</a>* visibleBounds);
<a name="l00507"></a>00507 
<a name="l00508"></a>00508     };
<a name="l00509"></a>00509 
<a name="l00513"></a>00513 }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 <span class="preprocessor">#include &quot;<a class="code" href="OgreHeaderSuffix_8h.html">OgreHeaderSuffix.h</a>&quot;</span>
<a name="l00516"></a>00516 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
